// Suma elementow tablicy
// http://www.algorytm.org
#include <iostream>

// Funkcja zwraca sume "size" elementow tablicy wskazanej przez "array"
// Uwaga: mozliwe jest ze suma elementow bedzie poza zakresem zwracanego typu T
template <typename T> T arraySum(const T *array, size_t size)
{
    // Poczatkowo suma wynosi zero
    T sum = 0;
    
    // Powtarzaj dla "size" pierwszych elementow tablicy array    
    for (size_t i = 0; i < size; ++i)
    {
        // Dodaj do sumy wartosc i-tego elementu
        sum += array[i];
    }    
    
    // Zwroc sume    
    return sum;
}

int main()
{
    // Stala tablica 10 liczb calkowitych
    const int int_array[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 0};
    
    // Liczba elementow = rozmiar calej tablicy / rozmiar pojedynczego elementu
    std::cout << arraySum(int_array, sizeof(int_array) / sizeof(int));

    // Poprawne zakonczenie programu
    return EXIT_SUCCESS;
}
